package org.yaoqiang.bpmn.editor.dialog;

import java.awt.Container;

import org.json.JSONObject;
import org.yaoqiang.bpmn.editor.BPMNEditor;
import org.yaoqiang.graph.editor.dialog.Panel;
import org.yaoqiang.graph.editor.dialog.PanelContainer;

/**
 * JSONPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class JSONPanel extends Panel {

	private static final long serialVersionUID = 1L;

	public JSONPanel(PanelContainer pc, Object owner) {
		super(pc, owner);
	}

	public void saveObjects() {
		JSONPanel parentPanel = getParentPanel();
		if (parentPanel != null) {
			((JSONTablePanel) parentPanel).addRow(getOwner());
		}
	}

	public JSONPanelContainer getPanelContainer() {
		return (JSONPanelContainer) panelContainer;
	}

	public JSONObject getOwner() {
		return (JSONObject) owner;
	}

	public JSONDialog getDialog() {
		for (Container p = getPanelContainer().getParent(); p != null; p = p.getParent()) {
			if (p instanceof JSONDialog) {
				return (JSONDialog) p;
			}
		}
		return null;
	}

	public BPMNEditor getEditor() {
		if (getDialog() != null) {
			return getDialog().getEditor();
		}
		return null;
	}
	
	public JSONPanel getParentPanel() {
		if (getDialog() != null) {
			return getDialog().getParentPanel();
		}
		return null;
	}

}
