package org.yaoqiang.bpmn.editor.dialog.panels;

import java.util.List;

import org.yaoqiang.bpmn.editor.dialog.BPMNPanelContainer;
import org.yaoqiang.bpmn.editor.dialog.XMLComboPanel;
import org.yaoqiang.bpmn.editor.dialog.XMLPanel;
import org.yaoqiang.bpmn.model.BPMNModelUtils;
import org.yaoqiang.bpmn.model.elements.activities.CallActivity;
import org.yaoqiang.bpmn.model.elements.core.infrastructure.Definitions;
import org.yaoqiang.bpmn.model.elements.process.BPMNProcess;

/**
 * CallActivityPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CallActivityPanel extends XMLPanel {

	private static final long serialVersionUID = 1L;

	protected XMLComboPanel calledElementPanel;

	protected String calledElement;
	
	public CallActivityPanel(BPMNPanelContainer pc, CallActivity owner) {
		super(pc, owner);
		Definitions defs = BPMNModelUtils.getDefinitions(owner);
		calledElement = owner.getCalledElement();
		List<String> choices = null;
		boolean isProcess = defs.getRootElement(calledElement) == null || defs.getRootElement(calledElement) instanceof BPMNProcess;
		if (isProcess) {
			choices = defs.getProcessIds();
		}
		if (!choices.contains(calledElement)) {
			choices.add(calledElement);
		}
		BPMNProcess process = BPMNModelUtils.getDefaultProcess(defs);
		if (process != null) {
			choices.remove(process.getId());
		}
		calledElementPanel = new XMLComboPanel(pc, owner.get("calledElement"), "calledElement", choices, false, true, true);
		this.add(calledElementPanel);
	}

	public void saveObjects() {
		String newCalledElement = calledElementPanel.getSelectedItem().toString();
		if (newCalledElement.length() > 0) {
			if (!newCalledElement.equals(calledElement)) {
				
			}
			calledElementPanel.saveObjects();
		}
	}

}
