package org.yaoqiang.bpmn.editor.dialog.panels;

import java.util.List;

import org.yaoqiang.bpmn.editor.dialog.XMLComboPanel;
import org.yaoqiang.bpmn.editor.dialog.BPMNPanelContainer;
import org.yaoqiang.bpmn.editor.dialog.XMLPanel;
import org.yaoqiang.bpmn.model.BPMNModelUtils;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.activities.Activity;
import org.yaoqiang.bpmn.model.elements.core.common.FlowNode;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;
import org.yaoqiang.bpmn.model.elements.data.DataInput;
import org.yaoqiang.bpmn.model.elements.events.CatchEvent;
import org.yaoqiang.bpmn.model.elements.events.ThrowEvent;

/**
 * SelectDataInOutPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class SelectDataInOutPanel extends XMLPanel {

	private static final long serialVersionUID = 1L;

	protected XMLComboPanel dataInOutPanel;

	public SelectDataInOutPanel(BPMNPanelContainer pc, FlowNode owner, String type) {
		super(pc, owner);
		List<XMLElement> choices = BPMNModelUtils.getDataInOuts(owner, type);
		dataInOutPanel = new XMLComboPanel(pc, owner, "Data", choices, false, false, true);
		this.add(dataInOutPanel);
	}

	public void saveObjects() {
		BaseElement data = (BaseElement) dataInOutPanel.getSelectedItem();
		if (data instanceof DataInput) {
			if (owner instanceof Activity) {
				((Activity) owner).getIoSpecification().getDataInputs().remove(data.getId());
				((Activity) owner).getIoSpecification().getDataInputs().add(data);
			} else if(owner instanceof ThrowEvent) {
				((ThrowEvent) owner).getDataInputs().remove(data.getId());
				((ThrowEvent) owner).getDataInputs().add(data);
			}
		} else {
			if (owner instanceof Activity) {
				((Activity) owner).getIoSpecification().getDataOutputs().remove(data.getId());
				((Activity) owner).getIoSpecification().getDataOutputs().add(data);
			} else if(owner instanceof CatchEvent) {
				((CatchEvent) owner).getDataOutputs().remove(data.getId());
				((CatchEvent) owner).getDataOutputs().add(data);
			}
		}
	}

}
