package org.yaoqiang.bpmn.model.elements.activities;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLFactory;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * ResourceRoles
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ResourceRoles extends XMLFactory {

	public ResourceRoles(XMLElement parent) {
		super(parent, "resources");
	}
	
	public XMLElement generateNewElement() {
		ResourceRole resource = new ResourceRole(this);
		resource.setId(createId(((BaseElement) getParent()).getId() + "_RES"));
		if (type.equals("performer")) {
			resource.setElementName("performer");
			return resource;
		} else if (type.equals("humanPerformer")) {
			resource.setElementName("humanPerformer");
			return resource;
		} else if (type.equals("potentialOwner")) {
			resource.setElementName("potentialOwner");
			return resource;
		} else if (type.equals("resourceRole")) {
			resource.setElementName("resourceRole");
			return resource;
		} else {
			return null;
		}
	}

}
