package org.yaoqiang.bpmn.model.elements.activities;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElements;

/**
 * Transaction
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Transaction extends SubProcess {

	public Transaction(FlowElements parent) {
		super(parent, "transaction");
	}

	protected void fillStructure() {
		XMLAttribute attrMethod = new XMLAttribute(this, "method", "##Compensate");

		super.fillStructure();
		add(attrMethod);
	}

	public final String getMethod() {
		return getMethodAttribute().toValue();
	}

	public final XMLAttribute getMethodAttribute() {
		return (XMLAttribute) get("method");
	}
	
	public final void setMethod(String method) {
		getMethodAttribute().setValue(method);
	}
	
}
