package org.yaoqiang.bpmn.model.elements.bpmndi;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLComplexElement;

/**
 * BPMNLabel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class BPMNLabel extends XMLComplexElement {

	public BPMNLabel(BPMNEdge parent) {
		super(parent);
	}

	public BPMNLabel(BPMNShape parent) {
		super(parent);
	}

	protected void fillStructure() {
		XMLAttribute attrId = new XMLAttribute(this, "id");
		XMLAttribute attrLabelStyle = new XMLAttribute(this, "labelStyle");
		Bounds refBounds = new Bounds(this);
		
		add(attrId);
		add(attrLabelStyle);
		add(refBounds);
	}

	public String getId() {
		return get("id").toValue();
	}

	public void setId(String id) {
		set("id", id);
	}

	public String getLabelStyle() {
		return get("labelStyle").toValue();
	}

	public void setLabelStyle(String labelStyle) {
		set("labelStyle", labelStyle);
	}

	public Bounds getBounds() {
		return (Bounds) get("Bounds");
	}
	
}
