package org.yaoqiang.bpmn.model.elements.core.common;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.RootElement;
import org.yaoqiang.bpmn.model.elements.core.foundation.RootElements;
import org.yaoqiang.bpmn.model.elements.core.infrastructure.Import;

/**
 * ItemDefinition
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ItemDefinition extends BaseElement implements RootElement {

	public ItemDefinition(RootElements parent) {
		super(parent, "itemDefinition");
	}

	public ItemDefinition(FormalExpression parent, String name) {
		super(parent, name);
	}

	protected void fillStructure() {
		XMLAttribute attrStructureRef = new XMLAttribute(this, "structureRef");
		XMLAttribute attrIsCollection = new XMLAttribute(this, "isCollection", Boolean.FALSE.toString());
		XMLAttribute attrItemKind = new XMLAttribute(this, "itemKind", ItemKind.Information.toString());
		Import refImport = new Import(this);

		super.fillStructure();
		add(attrStructureRef);
		add(attrIsCollection);
		add(attrItemKind);
		add(refImport);
	}

	public final String getStructureRef() {
		return get("structureRef").toValue();
	}
	
	public final boolean isCollection() {
		return Boolean.parseBoolean(get("isCollection").toValue());
	}
	
	public final void setIsCollection(boolean isCollection) {
		set("isCollection", String.valueOf(isCollection));
	}
	
	public final void setStructureRef(String structureRef) {
		set("structureRef", structureRef);
	}
	
	enum ItemKind {

		Information("Information"), Physical("Physical");

		private String itemKind;

		ItemKind(String itemKind) {
			this.setItemKind(itemKind);
		}

		public void setItemKind(String itemKind) {
			this.itemKind = itemKind;
		}

		public String getItemKind() {
			return itemKind;
		}

	}
}
