package org.yaoqiang.bpmn.model.elements.data;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElement;
import org.yaoqiang.bpmn.model.elements.core.common.FlowElements;

/**
 * DataObjectReference
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class DataObjectReference extends FlowElement implements ItemAwareElement {

	public DataObjectReference(FlowElements parent) {
		super(parent, "dataObjectReference");
	}

	protected void fillStructure() {
		XMLAttribute attrDataObjectRef = new XMLAttribute(this, "dataObjectRef");
		XMLAttribute attrItemSubjectRef = new XMLAttribute(this, "itemSubjectRef");
		DataState refDataState = new DataState(this);

		super.fillStructure();
		add(attrItemSubjectRef);
		add(attrDataObjectRef);
		add(refDataState);
	}

	public final String getDataObjectRef() {
		return get("dataObjectRef").toValue();
	}

	public final String getDataState() {
		return ((DataState) get("dataState")).getName();
	}

	public final DataObject getRefDataObject() {
		return (DataObject) getParent().get(getDataObjectRef());
	}

	public final void setDataObjectRef(String dataObjectRef) {
		set("dataObjectRef", dataObjectRef);
	}

	public final void setDataState(String dataState) {
		((DataState) get("dataState")).setName(dataState);
	}

}
