package org.yaoqiang.bpmn.model.elements.process;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * Lane
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Lane extends BaseElement {

	public Lane(Lanes parent) {
		super(parent, "lane");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLAttribute attrPartitionElementRef = new XMLAttribute(this, "partitionElementRef");
		XMLTextElements refFlowNodeRefs = new XMLTextElements(this, "flowNodeRef");
		LaneSet refChildLaneSet = new LaneSet(this);

		super.fillStructure();
		add(attrName);
		add(attrPartitionElementRef);
		add(refFlowNodeRefs);
		add(refChildLaneSet);
	}

	public Lanes getParent() {
		return (Lanes) parent;
	}

	public final String getName() {
		return get("name").toValue();
	}

	public final LaneSet getChildLaneSet() {
		return (LaneSet) get("childLaneSet");
	}

	public final XMLTextElements getFlowNodeRef() {
		return (XMLTextElements) get("flowNodeRef");
	}

	public final List<XMLElement> getFlowNodeList() {
		return getFlowNodeRef().getXMLElements();
	}

	public final void setName(String name) {
		set("name", name);
	}

	public final void addFlowNodeRef(String flowNodeid) {
		XMLElement flowNodeRef = getFlowNodeRef().generateNewElement();
		flowNodeRef.setValue(flowNodeid);
		getFlowNodeRef().add(flowNodeRef);
	}

	public void removeFlowNodeRef(String value) {
		getFlowNodeRef().remove(value);
	}

}
